searchNodes=[{"doc":"LcdDisplay is a simple Elixir library that allows you to control an Liquid-crystal display (LCD) like Hitachi HD44780.ExamplesAs an example, if you want to control a Hitachi HD44780 type display through I²C, you can use LcdDisplay.HD44780.I2C module as a display driver.alias LcdDisplay.{DisplaySupervisor, DisplayController, HD44780} # Start the LCD driver and get the initial display state. pid = LcdDisplay.start_display(HD44780.I2C, %{display_name: &quot;Display 1&quot;}) # Run a command. LcdDisplay.execute(pid, {:print, &quot;Hello world&quot;}) LcdDisplay.execute(pid, :clear)","ref":"LcdDisplay.html","title":"LcdDisplay","type":"module"},{"doc":"Executes a supported command that is specified.","ref":"LcdDisplay.html#execute/2","title":"LcdDisplay.execute/2","type":"function"},{"doc":"Finds or starts a supervised display controller process.","ref":"LcdDisplay.html#start_display/2","title":"LcdDisplay.start_display/2","type":"function"},{"doc":"Defines a behaviour required for GPIO abstraction.","ref":"LcdDisplay.CommunicationBus.GPIO.html","title":"LcdDisplay.CommunicationBus.GPIO","type":"behaviour"},{"doc":"","ref":"LcdDisplay.CommunicationBus.GPIO.html#c:open/2","title":"LcdDisplay.CommunicationBus.GPIO.open/2","type":"callback"},{"doc":"","ref":"LcdDisplay.CommunicationBus.GPIO.html#c:write/2","title":"LcdDisplay.CommunicationBus.GPIO.write/2","type":"callback"},{"doc":"Defines a behaviour required for I²C abstraction.","ref":"LcdDisplay.CommunicationBus.I2C.html","title":"LcdDisplay.CommunicationBus.I2C","type":"behaviour"},{"doc":"","ref":"LcdDisplay.CommunicationBus.I2C.html#c:open/1","title":"LcdDisplay.CommunicationBus.I2C.open/1","type":"callback"},{"doc":"","ref":"LcdDisplay.CommunicationBus.I2C.html#c:write/3","title":"LcdDisplay.CommunicationBus.I2C.write/3","type":"callback"},{"doc":"Wraps a given display driver and controls the display using that driver.","ref":"LcdDisplay.DisplayController.html","title":"LcdDisplay.DisplayController","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"LcdDisplay.DisplayController.html#child_spec/1","title":"LcdDisplay.DisplayController.child_spec/1","type":"function"},{"doc":"Delegates the specified operation to the display driver, and updates the state as needed.Examples DisplayController.execute(pid, {:print, &quot;Hello&quot;})","ref":"LcdDisplay.DisplayController.html#execute/2","title":"LcdDisplay.DisplayController.execute/2","type":"function"},{"doc":"Starts a display driver process and registers the process with a composite key of driver module and display name.","ref":"LcdDisplay.DisplayController.html#start_link/1","title":"LcdDisplay.DisplayController.start_link/1","type":"function"},{"doc":"Discovers a process by the composite key of driver module atom and display name.","ref":"LcdDisplay.DisplayController.html#whereis/1","title":"LcdDisplay.DisplayController.whereis/1","type":"function"},{"doc":"Defines a behaviour required for an LCD driver.","ref":"LcdDisplay.DisplayDriver.html","title":"LcdDisplay.DisplayDriver","type":"behaviour"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.DisplayDriver.html#c:execute/2","title":"LcdDisplay.DisplayDriver.execute/2","type":"callback"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.DisplayDriver.html#c:start/1","title":"LcdDisplay.DisplayDriver.start/1","type":"callback"},{"doc":"Stops the LCD driver.","ref":"LcdDisplay.DisplayDriver.html#c:stop/1","title":"LcdDisplay.DisplayDriver.stop/1","type":"callback"},{"doc":"Type that represents a supported display command.Supported CommandDescription:clearClear the display.:homeMove the cursor home.:printPrint a text at the current cursor.:writewrite a character (byte) at the current cursor.:set_cursorMove the cursor to the specified position (column and row).:cursorSwitch on/off the underline cursor.:displaySwitch on/off the display.:blinkSwitch on/off the block cursor.:autoscrollAutomatically scroll the display when a charactor is written.:backlightSwitch on/off the backlight.:entry_right_to_leftText is printed from right to left.:entry_left_to_rightText is printed from left to right.:scrollScroll left/right the display.:leftMove the cursor left.:rightMove the cursor right.:charProgram custom character to CGRAM.","ref":"LcdDisplay.DisplayDriver.html#t:command/0","title":"LcdDisplay.DisplayDriver.command/0","type":"type"},{"doc":"Type that represents the display state.","ref":"LcdDisplay.DisplayDriver.html#t:display/0","title":"LcdDisplay.DisplayDriver.display/0","type":"type"},{"doc":"Type that represents an available display feature.","ref":"LcdDisplay.DisplayDriver.html#t:feature/0","title":"LcdDisplay.DisplayDriver.feature/0","type":"type"},{"doc":"Supervises display controller processes.","ref":"LcdDisplay.DisplaySupervisor.html","title":"LcdDisplay.DisplaySupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"LcdDisplay.DisplaySupervisor.html#child_spec/1","title":"LcdDisplay.DisplaySupervisor.child_spec/1","type":"function"},{"doc":"Finds or creates a DisplayController process.Examples pid = DisplaySupervisor.display_controller(LcdDisplay.HD44780.I2C, %{display_name: &quot;display 1&quot;} )","ref":"LcdDisplay.DisplaySupervisor.html#display_controller/2","title":"LcdDisplay.DisplaySupervisor.display_controller/2","type":"function"},{"doc":"","ref":"LcdDisplay.DisplaySupervisor.html#start_link/1","title":"LcdDisplay.DisplaySupervisor.start_link/1","type":"function"},{"doc":"Lets you control GPIOs. A thin wrapper of elixir-circuits/circuits_gpio.","ref":"LcdDisplay.GPIO.html","title":"LcdDisplay.GPIO","type":"module"},{"doc":"Callback implementation for LcdDisplay.CommunicationBus.GPIO.open/2.","ref":"LcdDisplay.GPIO.html#open/2","title":"LcdDisplay.GPIO.open/2","type":"function"},{"doc":"Callback implementation for LcdDisplay.CommunicationBus.GPIO.write/2.","ref":"LcdDisplay.GPIO.html#write/2","title":"LcdDisplay.GPIO.write/2","type":"function"},{"doc":"Knows how to commuticate with HD44780 type display via GPIO pins. Supports the 4-bit mode only. You can turn on/off only one backlight LED.Examplesalias LcdDisplay.HD44780 config = %{ display_name: &quot;display 1&quot;, pin_rs: 2, pin_rw: 3, pin_en: 4, pin_d4: 23, pin_d5: 24, pin_d6: 25, pin_d7: 26, pin_led_5v: 12, } # Start the LCD driver and get the initial display state. {:ok, display} = HD44780.GPIO.start(config) # Run a command and the display state will be updated. {:ok, display} = HD44780.GPIO.execute(display, {:print, &quot;Hello world&quot;})","ref":"LcdDisplay.HD44780.GPIO.html","title":"LcdDisplay.HD44780.GPIO","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.GPIO.html#execute/2","title":"LcdDisplay.HD44780.GPIO.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.GPIO.html#start/1","title":"LcdDisplay.HD44780.GPIO.start/1","type":"function"},{"doc":"Stops the LCD driver.","ref":"LcdDisplay.HD44780.GPIO.html#stop/1","title":"LcdDisplay.HD44780.GPIO.stop/1","type":"function"},{"doc":"Knows how to commuticate with HD44780 type display via I2C. You can turn on/off only one backlight LED.Examplesalias LcdDisplay.HD44780 config = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } # Start the LCD driver and get the initial display state. {:ok, display} = HD44780.I2C.start(config) # Run a command and the display state will be updated. {:ok, display} = HD44780.I2C.execute(display, {:print, &quot;Hello world&quot;})","ref":"LcdDisplay.HD44780.I2C.html","title":"LcdDisplay.HD44780.I2C","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.I2C.html#execute/2","title":"LcdDisplay.HD44780.I2C.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.I2C.html#start/1","title":"LcdDisplay.HD44780.I2C.start/1","type":"function"},{"doc":"Stops the LCD driver.","ref":"LcdDisplay.HD44780.I2C.html#stop/1","title":"LcdDisplay.HD44780.I2C.stop/1","type":"function"},{"doc":"Lets you communicate with hardware devices using the I2C protocol. A thin wrapper of elixir-circuits/circuits_i2c.","ref":"LcdDisplay.I2C.html","title":"LcdDisplay.I2C","type":"module"},{"doc":"Callback implementation for LcdDisplay.CommunicationBus.I2C.open/1.","ref":"LcdDisplay.I2C.html#open/1","title":"LcdDisplay.I2C.open/1","type":"function"},{"doc":"Callback implementation for LcdDisplay.CommunicationBus.I2C.write/3.","ref":"LcdDisplay.I2C.html#write/3","title":"LcdDisplay.I2C.write/3","type":"function"},{"doc":"","ref":"LcdDisplay.ProcessRegistry.html","title":"LcdDisplay.ProcessRegistry","type":"module"},{"doc":"","ref":"LcdDisplay.ProcessRegistry.html#child_spec/1","title":"LcdDisplay.ProcessRegistry.child_spec/1","type":"function"},{"doc":"Starts a unique registry.","ref":"LcdDisplay.ProcessRegistry.html#start_link/0","title":"LcdDisplay.ProcessRegistry.start_link/0","type":"function"},{"doc":"Returns a standardized via-tuple for this registry.Examplesiex&gt; ProcessRegistry.via_tuple({DisplayController, 20}) {:via, Registry, {ProcessRegistry, {DisplayController, 20}}}","ref":"LcdDisplay.ProcessRegistry.html#via_tuple/1","title":"LcdDisplay.ProcessRegistry.via_tuple/1","type":"function"},{"doc":"Returns a PID or :undefined.Examplesiex&gt; ProcessRegistry.whereis_name({DisplayController, 20}) #PID&lt;0.235.0&gt;","ref":"LcdDisplay.ProcessRegistry.html#whereis_name/1","title":"LcdDisplay.ProcessRegistry.whereis_name/1","type":"function"},{"doc":"","ref":"LcdDisplay.Util.html","title":"LcdDisplay.Util","type":"module"},{"doc":"Determines a cursor position based on the number of rows, the number of columns, and the zero-indexed cursor row and column.Examplesiex&gt; LcdDisplay.Util.determine_cursor_position({2, 16}, {0,0}) 0 iex&gt; LcdDisplay.Util.determine_cursor_position({2, 16}, {0,15}) 15 iex&gt; LcdDisplay.Util.determine_cursor_position({2, 16}, {1,0}) 64 iex&gt; LcdDisplay.Util.determine_cursor_position({2, 16}, {1,15}) 79","ref":"LcdDisplay.Util.html#determine_cursor_position/2","title":"LcdDisplay.Util.determine_cursor_position/2","type":"function"}]